// EinsDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Eins.h"
#include "EinsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEinsDlg Dialogfeld

CEinsDlg::CEinsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEinsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEinsDlg)
	m_Takt = 0;
	m_VerfallRAND = 0;
	m_FreieRAND = 0;
	m_Person = 0;
	m_Nachricht = _T("");
	m_Kettentyp = 1;
	m_Selbstaendig = FALSE;
	m_GueltigkeitRAND = GUELTIGKEITRAND;
	m_WertungRAND = RANDWERTIGKEIT;
	m_GueltigkeitKante = GUELTIGKEITKANTE;
	m_TrustServerSchenkhaeufigkeit = TRUSTSERVERSCHENKHAEUFIGKEIT;
	m_PersonenSchenkhaeufigkeit = PERSONENSCHENKHAEUFIGKEIT;
	m_StartClients = 10;
	m_PersonenMisstrauhaeufigkeit = 10;
	m_Qualifiziert = _T("");
	m_MaxTeilnehmer = 30;
	m_Aktiv = 0;
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEinsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEinsDlg)
	DDX_Control(pDX, IDC_LIST_UMSCHLAG, m_Umschlag);
	DDX_Control(pDX, IDC_LIST_VERTRAUEN, m_Vertrauen);
	DDX_Control(pDX, IDC_LIST_CLIENTS, m_Clients);
	DDX_Text(pDX, IDC_EDIT_TAKT, m_Takt);
	DDX_Text(pDX, IDC_EDIT_VERFALL_RAND, m_VerfallRAND);
	DDX_Text(pDX, IDC_EDIT_FREIE_RAND, m_FreieRAND);
	DDX_Text(pDX, IDC_EDIT_PERSON, m_Person);
	DDX_Text(pDX, IDC_EDIT_NACHRICHT, m_Nachricht);
	DDX_Radio(pDX, IDC_RADIO_ZUFAELLIG, m_Kettentyp);
	DDX_Check(pDX, IDC_CHECK_SELBSTAENDIG, m_Selbstaendig);
	DDX_Text(pDX, IDC_EDIT_GUELTIGKEIT_RAND, m_GueltigkeitRAND);
	DDX_Text(pDX, IDC_EDIT_WERTUNG_RAND, m_WertungRAND);
	DDX_Text(pDX, IDC_EDIT_GUELTIGKEIT_KANTE, m_GueltigkeitKante);
	DDX_Text(pDX, IDC_EDIT_TRUSTSERVER_VERSCHENKHAEUFIGKEIT, m_TrustServerSchenkhaeufigkeit);
	DDX_Text(pDX, IDC_EDIT_PERSONENVERSCHENKHAEUFIGKEIT, m_PersonenSchenkhaeufigkeit);
	DDX_Text(pDX, IDC_EDIT_QUALIFIZIERTE_PERSONEN, m_StartClients);
	DDX_Text(pDX, IDC_EDIT_PERSONENMISSTRAUHAEUFIGKEIT, m_PersonenMisstrauhaeufigkeit);
	DDX_Text(pDX, IDC_EDIT_QUALIFIZIERT, m_Qualifiziert);
	DDX_Text(pDX, IDC_EDIT_MAXTEILNEHMER, m_MaxTeilnehmer);
	DDX_Text(pDX, IDC_EDIT_AKTIV, m_Aktiv);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEinsDlg, CDialog)
	//{{AFX_MSG_MAP(CEinsDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_NAECHSTER_TAKT, OnButtonNaechsterTakt)
	ON_LBN_SELCHANGE(IDC_LIST_CLIENTS, OnSelchangeListClients)
	ON_BN_CLICKED(IDC_BUTTON_VERTRAUEN_SCHENKEN, OnButtonVertrauenSchenken)
	ON_LBN_DBLCLK(IDC_LIST_VERTRAUEN, OnDblclkListVertrauen)
	ON_BN_CLICKED(IDC_BUTTON_VERTRAUEN_ENTZIEHEN, OnButtonVertrauenEntziehen)
	ON_BN_CLICKED(IDC_BUTTON_NACHRICHT_VERSENDEN, OnButtonNachrichtVersenden)
	ON_BN_CLICKED(IDC_BUTTON_VERTRAUENSKETTE, OnButtonVertrauenskette)
	ON_BN_CLICKED(IDC_BUTTON_NACHRICHT_LESEN, OnButtonNachrichtLesen)
	ON_BN_CLICKED(IDC_BUTTON_INITIALISIEREN, OnButtonInitialisieren)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEinsDlg Nachrichten-Handler

BOOL CEinsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CEinsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CEinsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// Netz und TrustServer global deklarieren, nur einmal vorhanden
CNetz Netz;
CTrustServer TrustServer;


// Anzeigen fast aller Daten im Dialog, in jedem Takt aufgerufen
void CEinsDlg::Anzeigen()
{
	// Liste Teilnehmer lschen
	m_Clients.ResetContent();
	
	// alle Personen durchlauf
	int nLauf;
	for (nLauf=0; nLauf<TrustServer.nMaxTeilnehmer; nLauf++)
		// wenn aktiv oder qualifiziert, dann in Liste ausgeben
		if ((Netz.arClients[nLauf].bAktiv)||(Netz.arClients[nLauf].nFreieRAND>0)||
			(Netz.arClients[nLauf].bQualifiziert))
		{
			// Nummer und Status anzeigen
			CString strAusgabe;
			strAusgabe.Format("Client-ID %i ",nLauf);
			if (Netz.arClients[nLauf].bAktiv)
				strAusgabe += "(aktiv)";
			else
				strAusgabe += "(inaktiv)";

			m_Clients.AddString(strAusgabe);
			// ID zum spteren Abruf speichern
			m_Clients.SetItemData(m_Clients.FindStringExact(0,strAusgabe),nLauf);
		}

	// Takt und Anzahl aktiver Teilnehmer ausgeben
	m_Takt = TrustServer.nTakt;
	m_Aktiv = TrustServer.nAktive;

	// Daten in Dialog eintragen
	UpdateData(false);
}


// Takt vollziehen
void CEinsDlg::OnButtonNaechsterTakt() 
{
	// Daten aus Dialog holen
	UpdateData();

	// Daten dem TrustServer mitteilen
	TrustServer.nDauerRAND = m_GueltigkeitRAND;
	TrustServer.nDauerKante = m_GueltigkeitKante;
	TrustServer.nRANDWertigkeit = m_WertungRAND;
	TrustServer.nSchenkhaeufigkeit = (m_TrustServerSchenkhaeufigkeit*RAND_MAX)/100;
	TrustServer.nClientsSchenkhaeufigkeit = (m_PersonenSchenkhaeufigkeit*RAND_MAX)/100;
	TrustServer.nClientsMisstrauhaeufigkeit = (m_PersonenMisstrauhaeufigkeit*RAND_MAX)/100;
	TrustServer.bSelbstaendig = m_Selbstaendig;
	TrustServer.nStartClients = m_StartClients;
	TrustServer.nMaxTeilnehmer = m_MaxTeilnehmer;
	
	// Netz soll Nachrichten weiterverschicken
	Netz.ErledigeTakt();

	// alle Teilnehmer erhalten Zeit, ihre Post und ihre Beziehungen zu pflegen
	int nLauf;
	for (nLauf=0; nLauf<TrustServer.nMaxTeilnehmer; nLauf++)
		Netz.arClients[nLauf].ErledigeTakt();

	// TrustServer darf seine Arbeiten erledigen
	TrustServer.ErledigeTakt();

	// Anzeige auffrischen
	Anzeigen();
	// gewhlten Teilnehmer anzeigen (funktioniert nicht immer !)
	OnSelchangeListClients();
}


// bei Auswahl eines speziellen Teilnehmers
void CEinsDlg::OnSelchangeListClients() 
{
	CString strAusgabe;
	int nLauf;

	// ID des Gewhlten holen, Fehlauswahl abfangen
	if (m_Clients.GetCurSel()==LB_ERR)
		return;
	int ID = m_Clients.GetItemData(m_Clients.GetCurSel());

	// seine RAND-Daten ausgeben
	m_VerfallRAND = TrustServer.arVerfallstaktRAND[ID];
	m_FreieRAND = Netz.arClients[ID].nFreieRAND;
	
	// Poststatus ausgeben
	m_Umschlag.ResetContent();
	strAusgabe.Format("%imal weiterleiten", Netz.arClients[ID].arWeiterleiten.GetCount());
	m_Umschlag.AddString(strAusgabe);
	strAusgabe.Format("%imal lesen", Netz.arClients[ID].arPrivatePost.GetCount());
	m_Umschlag.AddString(strAusgabe);

	// ausgeben, ob diese Person qualifiziert ist
	if (Netz.arClients[ID].bQualifiziert)
		m_Qualifiziert = "qualifiziert";
	else
		m_Qualifiziert = "nicht qualifiziert";

	// Ausgabe der Personen, denen vertraut wird
	m_Vertrauen.ResetContent();
	for (nLauf=0; nLauf<TrustServer.nMaxTeilnehmer; nLauf++)
		if (TrustServer.arVertrauen[ID][nLauf]>0)
		{
			strAusgabe.Format("vertraut ID %i",nLauf);

			m_Vertrauen.AddString(strAusgabe);
			m_Vertrauen.SetItemData(m_Vertrauen.FindStringExact(0,strAusgabe),nLauf);
		}
	// Ausgabe der Personen, denen mitraut wird
	for (nLauf=0; nLauf<TrustServer.nMaxTeilnehmer; nLauf++)
		if (TrustServer.arVertrauen[ID][nLauf]==Misstrauen)
		{
			strAusgabe.Format("mitraut ID %i",nLauf);

			m_Vertrauen.AddString(strAusgabe);
			m_Vertrauen.SetItemData(m_Vertrauen.FindStringExact(0,strAusgabe),nLauf);
		}

	UpdateData(false);
}


// einer Person soll Vertrauen geschenkt werden
void CEinsDlg::OnButtonVertrauenSchenken() 
{
	// ID des Schenkenden holen, Fehler abfangen
	if (m_Clients.GetCurSel()==LB_ERR)
		return;
	int ID = m_Clients.GetItemData(m_Clients.GetCurSel());
	
	// Schenkender und Empfnger identisch ?
	if (ID==m_Person)
		return;

	// wenn keine RAND frei, dann ist Verschenken nicht mglich
	if (Netz.arClients[ID].nFreieRAND==0)
		return;

	UpdateData();

	// den TrustServer mit Registrierung beauftragen
	TrustServer.SchenkeVertrauen(ID, m_Person);

	// Anzeige aktualisieren
	OnSelchangeListClients();
}


// einer Person Vertrauen entziehen
void CEinsDlg::OnButtonVertrauenEntziehen() 
{
	// Absender-ID holen
	if (m_Clients.GetCurSel()==LB_ERR)
		return;
	
	int ID = m_Clients.GetItemData(m_Clients.GetCurSel());

	// Absender und Empfnger identisch ?
	if (ID==m_Person)
		return;

	UpdateData();

	// TrustServer beauftragen
	TrustServer.EntzieheVertrauen(ID, m_Person);

	OnSelchangeListClients();
}


// neue Zielperson in Liste ausgewhlt
void CEinsDlg::OnDblclkListVertrauen() 
{
	// Zielperson ndern
	m_Person = m_Vertrauen.GetItemData(m_Vertrauen.GetCurSel());
	UpdateData(false);
}


// Nachricht versenden
void CEinsDlg::OnButtonNachrichtVersenden() 
{
	TKette Kette;

	// Daten holen
	UpdateData();

	// Empfnger und Absender bestimmen
	if (m_Clients.GetCurSel()==LB_ERR)
		return;
	int Von = m_Clients.GetItemData(m_Clients.GetCurSel());
	int An = m_Person;

	// Empfnger und Absender drfen nicht identisch sein
	if (Von==An)
		return;

	// prfen, ob Vertrauenskette gefunden
	if(TrustServer.ErmittleVertrauenskette(Von,An,m_Kettentyp,Kette))
	{
		CString strAusgabe;
		CUmschlag Umschlag;
		// Absender der Nachricht voranstellen
		strAusgabe.Format("(von: ID %i) ",Von);
		Umschlag.strNachricht = strAusgabe+m_Nachricht;
		
		// Ende der Kette suchen (Empfnger)
		int nLauf = 0;
		while (Kette[nLauf]!=An)
			nLauf++;

		// Umschlag versandbereit machen, notfalls verschachteln
		Umschlag.Versandfertig(Kette,nLauf);
		// Umschlag an das Netz schicken
		Netz.EmpfangeNachricht(Umschlag);

		// Erfolgsmeldung
		strAusgabe.Format("an ID %i verschickt",An);
		m_Umschlag.AddString(strAusgabe);

		// Nachrichtenfeld lschen
		m_Nachricht = "";
	}
	else
		// Fehlermeldung
		AfxMessageBox("Nicht mglich.");
}


// Vertrauenskette abfragen
void CEinsDlg::OnButtonVertrauenskette() 
{
	TKette Kette;

	UpdateData();

	// Empfnger und Absender auslesen
	if (m_Clients.GetCurSel()==LB_ERR)
		return;
	int Von = m_Clients.GetItemData(m_Clients.GetCurSel());
	int An = m_Person;

	// testen, ob Vertrauenskette mglich
	bool bMoeglich = TrustServer.ErmittleVertrauenskette(Von,An,m_Kettentyp,Kette);
	
	// Statusausgabe vorbereiten
	CString strAusgabe;
	strAusgabe.Format("Nachricht von Client-ID %i an Client-ID %i versenden:\n",Von,An);
	// abfragen, ob Kette gefunden
	if (bMoeglich)
	{
		// Kette durchlaufen, bis Empfnger gefunden
		int nLauf = 1;
		while (Kette[nLauf]!=An)
		{
			// Zwischenpersonen ausgeben
			CString strTemp;
			strTemp.Format("Client-ID %i",Kette[nLauf]);
			strAusgabe += strTemp+"\n";

			// nchste Person
			nLauf++;
		}

		// direkte Zustellung ?
		if (Kette[1]==An)
			strAusgabe += "direkt";
	}
	else
		// Kette nicht mglich
		strAusgabe += "nicht mglich";
		
	// Ausgabe Status
	AfxMessageBox(strAusgabe);
}


// Nachricht lesen
void CEinsDlg::OnButtonNachrichtLesen() 
{
	// Teilnehmer-ID auslesen
	if (m_Clients.GetCurSel()==LB_ERR)
		return;
	int ID = m_Clients.GetItemData(m_Clients.GetCurSel());

	// Nachricht holen
	CString strLesen = Netz.arClients[ID].LeseNachricht();
	// Nachricht anzeigen
	m_Nachricht = strLesen;

	UpdateData(false);
}


// Initialisierung des Netzes
void CEinsDlg::OnButtonInitialisieren() 
{
	UpdateData();
	
	// TrustServer-Einstellungen aktualisieren
	TrustServer.nAktive = 0;
	TrustServer.nMaxTeilnehmer = m_MaxTeilnehmer;
	TrustServer.nStartClients = m_StartClients;
	// Netz initialisieren
	Netz.Initialisieren();
	// TrustServer-Einstellungen weiter aktualisieren
	TrustServer.nDauerRAND = m_GueltigkeitRAND;
	TrustServer.nDauerKante = m_GueltigkeitKante;
	TrustServer.nRANDWertigkeit = m_WertungRAND;
	TrustServer.nSchenkhaeufigkeit = (m_TrustServerSchenkhaeufigkeit*RAND_MAX)/100;
	TrustServer.nClientsSchenkhaeufigkeit = (m_PersonenSchenkhaeufigkeit*RAND_MAX)/100;
	TrustServer.nClientsMisstrauhaeufigkeit = (m_PersonenMisstrauhaeufigkeit*RAND_MAX)/100;
	TrustServer.bSelbstaendig = m_Selbstaendig;
	// TrustServer initialisieren
	TrustServer.Initialisieren();

	// Daten anzeigen
	Anzeigen();

	// Ersten Takt vollziehen
	OnButtonNaechsterTakt();
}


// Klasse CTrustServer

// Konstruktor
CTrustServer::CTrustServer()
{
	// Standard-Einstellungen
	nDauerRAND = GUELTIGKEITRAND;
	nDauerKante = GUELTIGKEITKANTE;
	nRANDWertigkeit = RANDWERTIGKEIT;
	nSchenkhaeufigkeit = (TRUSTSERVERSCHENKHAEUFIGKEIT*RAND_MAX)/100;
	nClientsSchenkhaeufigkeit = (PERSONENSCHENKHAEUFIGKEIT*RAND_MAX)/100;
	nClientsMisstrauhaeufigkeit = (10*RAND_MAX)/100;
	nStartClients = 10;
	nMaxTeilnehmer = 30;

	// Initialisierung
	Initialisieren();
}


// Anmeldung eines Teilnehmers
void CTrustServer::Anmelden(int ID, TRAND Rand)
{
	// aktivieren
	Netz.arClients[ID].bAktiv = true;
	// privaten und ffentlichen Schlssel erzeugen
	Netz.arClients[ID].NeueSchluessel(GeneriereSchluessel(),GeneriereSchluessel());

	// RAND-Gltigkeit eintragen
	ErneuereRAND(ID,Rand);

	// Anzahl Aktiver erhhen
	nAktive++;
}


// Abmeldung eines Teilnehmers
void CTrustServer::Abmelden(TID ID)
{
	// Teilnehmer deaktivieren
	Netz.arClients[ID].bAktiv = false;

	// alle Vertrauensbeziehungen lschen
	int nLauf;
	for (nLauf=0; nLauf<nMaxTeilnehmer; nLauf++)
	{
		arVertrauen[ID][nLauf] = 0;
		arVertrauen[nLauf][ID] = 0;
	}

	// ein Teilnehmer weniger
	nAktive--;
}


// Schlssel erzeugen
TKey CTrustServer::GeneriereSchluessel()
{
	// Zufallszahl zurckgeben
	return rand();
}


// RAND erzeugen
TRAND CTrustServer::GeneriereRAND()
{
	// Zufallszahl zurckgeben
	return rand();
}


// selbstndig neue RAND verschenken
void CTrustServer::VerschenkeRAND()
{
	// alle qualifizierten Teilnehmer durchlaufen
	// per Zufall RAND zuweisen (eingestellte Hufigkeit)
	int nLauf;
	for (nLauf=0; nLauf<nMaxTeilnehmer; nLauf++)
		if ((Netz.arClients[nLauf].bQualifiziert)&&
			(rand()<nSchenkhaeufigkeit))
			Netz.arClients[nLauf].EmpfangeRAND(GeneriereRAND());
}


// Takt erledigen
void CTrustServer::ErledigeTakt()
{
	// neue RAND verschenken
	VerschenkeRAND();

	// Takt erhhen
	nTakt++;
}


// RAND-Erneuerung registrieren
void CTrustServer::ErneuereRAND(TID ID, TRAND Rand)
{
	// Verfallstakt neu einstellen
	arVerfallstaktRAND[ID] = nTakt+nDauerRAND;
}


// Vertrauensschenkung registrieren
void CTrustServer::SchenkeVertrauen(TID Von, TID An)
{
	TRAND tempRAND;
	
	// Absender und Empfnger identisch ?
	if (Von==An)
		return;

	// RAND vom Absender zum Empfnger transportieren
	tempRAND = Netz.arClients[Von].VersendeRAND();
	Netz.arClients[An].EmpfangeRAND(tempRAND);

	// neue Vertrauenskante erzeugen
	arVertrauen[Von][An] = nTakt+nDauerKante;
	arVertrauen[An][Von] = nTakt+nDauerKante;
}


// Vertrauen entziehen
void CTrustServer::EntzieheVertrauen(TID Von, TID An)
{
	// Vertrauenskanten auf Mitrauen umstellen
	arVertrauen[Von][An] = Misstrauen;
	arVertrauen[An][Von] = Misstrauen;
}


// Vertrauenskette erstellen
bool CTrustServer::ErmittleVertrauenskette(TID Von, TID An, int Typ, TKette Kette)
{
	// Struktur zur Optimierung
	typedef struct
	{
		bool bOptimal;
		int nLaenge;
		TID nNachfolger;
	} TElement;
	// Optimierungsliste mit allen Teilnehmern
	TElement Liste[MaxClients];
	// Personen, die in der Kette nicht auftauchen drfen
	bool arMisstrauen[MaxClients];

	// zuerst wird allen vertraut
	memset(arMisstrauen, false, sizeof(arMisstrauen));

	// Optimierungsliste initialisieren
	int nLauf;
	for (nLauf=0; nLauf<nMaxTeilnehmer; nLauf++)
	{
		Liste[nLauf].bOptimal = false;
		Liste[nLauf].nLaenge = INT_MAX;
		Liste[nLauf].nNachfolger = INT_MAX;
	}

	// Empfnger ist optimal
	Liste[An].nLaenge = 0;
	Liste[An].bOptimal = true;
	// alle Personen eintragen, denen er mitraut
	for(nLauf=0; nLauf<nMaxTeilnehmer; nLauf++)
		if (TrustServer.arVertrauen[An][nLauf]==Misstrauen)
			arMisstrauen[nLauf]=true;

	// Vertraute des Empfngers eintragen
	for(nLauf=0; nLauf<nMaxTeilnehmer; nLauf++)
		if (arVertrauen[nLauf][An]>=nTakt)
		{
			Liste[nLauf].nLaenge = BewerteVertrauen(Typ,nLauf,An);
			Liste[nLauf].nNachfolger = An;
		}

	// bis Kette gefunden
	bool bFertig = false;
	while (!bFertig)
	{
		// enthalten die nheste Person
		int nMinLaenge = INT_MAX;
		int nMinID = INT_MAX;

		// nicht-optimierten Teilnehmer mit der grten Nhe zum Empfnger suchen
		for (nLauf=0; nLauf<nMaxTeilnehmer; nLauf++)
			if ((!Liste[nLauf].bOptimal)&&(Liste[nLauf].nLaenge<nMinLaenge)&&
				(arVertrauen[nLauf]))
			{
				// Daten eintragen
				nMinLaenge = Liste[nLauf].nLaenge;
				nMinID = nLauf;
			}

		// niemand gefunden => Abbruch, keine Kette
		if (nMinID==INT_MAX)
			return false;

		// von der "Minimalperson" Vertraute minimieren
		for (nLauf=0; nLauf<nMaxTeilnehmer; nLauf++)
		{
			int tempLaenge = Liste[nMinID].nLaenge+BewerteVertrauen(Typ,nMinID,nLauf);

			// falls ber "Minimalperson" Vertraute schneller erreichbar
			if ((arVertrauen[nMinID][nLauf]>=nTakt)&&(tempLaenge<Liste[nLauf].nLaenge))
			{
				// Daten ndern
				Liste[nLauf].nLaenge = tempLaenge;
				Liste[nLauf].nNachfolger = nMinID;
			}
		}

		// "Minimalperson" ist optimal erreichbar
		Liste[nMinID].bOptimal = true;
		// Personen, denen mitraut wird, eintragen
		for (nLauf=0; nLauf<nMaxTeilnehmer; nLauf++)
			if (TrustServer.arVertrauen[An][nLauf]==Misstrauen)
				arMisstrauen[nLauf]=true;
		
		// wenn Absender gefunden, dann Ende
		bFertig = (nMinID==Von);
	}

	// vom Absender aus Route zurckverfolgen
	int nIterator = Von;
	nLauf = 0;
	while(nIterator!=An)
	{
		// Person in Kette eintragen
		Kette[nLauf] = nIterator;
		// nchste Person in der Kette nehmen
		nIterator = Liste[nIterator].nNachfolger;

		// in der Kettenspeicherung weiter
		nLauf++;
	}
	// Empfnger eintragen
	Kette[nLauf] = An;

	// Kette gefunden
	return true;
}


// Vertrauensbeziehung bewerten
int CTrustServer::BewerteVertrauen(int Typ, TID Von, TID An)
{
	// Vertrauenskettentyp unterscheiden
	switch(Typ)
	{
		// zufllige Bedeutung
		case Zufaellig:
			return ((rand()*10)/RAND_MAX)+1;
		// Bedeutung 1
		case Kurz:
			return 1;
		// Bedeutung nach Anzahl RAND und Aktualitt Vertrauen
		case Verlaesslich:
			return (nDauerKante-(arVertrauen[Von][An]-nTakt)+
				    nRANDWertigkeit/(Netz.arClients[Von].nFreieRAND+
				                     Netz.arClients[An].nFreieRAND)+1);
	}
	// Unterdrckung Warnung des Compilers
	return 0;
}


// TrustServer initialisieren
void CTrustServer::Initialisieren()
{
	// auf Takt 0
	nTakt = 0;
	// Zufallsgenerator initialisieren
	srand(time(NULL));
	
	// qualifizierte Teilnehmer markieren und anmelden
	int nLauf;
	for (nLauf=0; nLauf<nMaxTeilnehmer; nLauf++)
	{
		if (nLauf<nStartClients)
		{
			Anmelden(nLauf, GeneriereRAND());
			Netz.arClients[nLauf].bQualifiziert = true;
		}
		else
			Netz.arClients[nLauf].bQualifiziert = false;
	}

	// Vertrauensbeziehungen lschen
	memset(arVertrauen,0,sizeof(arVertrauen));
}


// Klasse CNetz

// Konstruktor
CNetz::CNetz()
{
	// Netz initialisieren
	Initialisieren();
}


// Takt vollziehen
void CNetz::ErledigeTakt()
{
	// solange Nachrichten zu transportieren sind
	while(!arNachrichten.IsEmpty())
	{
		// Umschlag holen
		CUmschlag Umschlag = arNachrichten.GetHead();
		// wenn Empfnger noch existiert, dann zustellen
		if (arClients[Umschlag.nEmpfaengerID].bAktiv)
			arClients[Umschlag.nEmpfaengerID].EmpfangeNachricht(Umschlag);
		else
		{
			// Fehlermeldung, da unzustellbar
			CString strAusgabe;
			strAusgabe.Format("Nachricht an ID %i verloren",Umschlag.nEmpfaengerID);
			AfxMessageBox(strAusgabe);
		}
		// Umschlag ist bearbeitet, also lschen
		arNachrichten.RemoveHead();
	}
}


// Nachricht empfangen
void CNetz::EmpfangeNachricht(CUmschlag Umschlag)
{
	// zu bisherigen Umschlag hinzufgen
	arNachrichten.AddTail(Umschlag);
}


// Netz initialisieren
void CNetz::Initialisieren()
{
	int nLauf;
	// alle Teilnehmer initialisieren
	for (nLauf=0; nLauf<MaxClients; nLauf++)
	{
		arClients[nLauf].ID = nLauf;
		arClients[nLauf].bAktiv = false;
		arClients[nLauf].bQualifiziert = false;
		arClients[nLauf].nFreieRAND = 0;
		arClients[nLauf].arRAND.RemoveAll();
	}

	// alle Nachrichten lschen
	arNachrichten.RemoveAll();
}


// Klasse CClient

// Konstruktor, nichts zu tun
CClient::CClient()
{
}


// neue Schlssel erhalten
void CClient::NeueSchluessel(TKey Oeffentlich, TKey Privat)
{
	// privaten und ffentlichen Schlssel eintragen
	nOeffentlicherSchluessel = Oeffentlich;
	nPrivaterSchluessel = Privat;
}


// neues RAND empfangen
void CClient::EmpfangeRAND(TRAND Rand)
{
	// zu freien RAND hinzufgen
	arRAND.AddTail(Rand);
	// Anzahl erhhen
	nFreieRAND++;
}


// RAND verschicken
TRAND CClient::VersendeRAND()
{
	// wenn keine frei, dann Abbruch
	if (nFreieRAND==0)
		return 0;
	
	TRAND tempRAND;
	
	// freies RAND auslesen
	tempRAND = arRAND.GetTail();
	// in der Liste lschen
	arRAND.RemoveTail();
	// Anzahl verringern
	nFreieRAND--;

	// RAND bergeben
	return tempRAND;
}


// Nachricht empfangen
void CClient::EmpfangeNachricht(CUmschlag Umschlag)
{
	// der eingehenden Post hinzufgen
	arEingehendePost.AddTail(Umschlag);
}


// Takt erledigen
void CClient::ErledigeTakt()
{
	// wenn nicht aktiv und kein RAND frei, dann Abbruch
	if ((bAktiv==false)&&(nFreieRAND==0))
		return;
	
	// nicht aktiv, aber RAND frei => anmelden
	if ((bAktiv==false)&&(nFreieRAND>0))
		TrustServer.Anmelden(ID, VersendeRAND());
	
	// aktuelles RAND gerade verfallen ?
	if (TrustServer.nTakt>=TrustServer.arVerfallstaktRAND[ID])
	{
		// RAND erneuerbar ?
		if (nFreieRAND>0)
			// ja
			TrustServer.ErneuereRAND(ID, VersendeRAND());
		else
			// nein, abmelden
			TrustServer.Abmelden(ID);
	}

	// selbstndiges Vertrauensverhalten ?
	if (TrustServer.bSelbstaendig)
	{
		// wenn RAND frei und Zufall entspricht Wahrscheinlichkeit, dann Vertrauen schenken
		if ((nFreieRAND>0)&&(rand()<TrustServer.nClientsSchenkhaeufigkeit))
			TrustServer.SchenkeVertrauen(ID,TrustServer.nMaxTeilnehmer*rand()/RAND_MAX);
		// nach Wahrscheinlichkeit Mitrauen aussprechen
		if (rand()<TrustServer.nClientsMisstrauhaeufigkeit)
			TrustServer.EntzieheVertrauen(ID,TrustServer.nMaxTeilnehmer*rand()/RAND_MAX);
	}

	// private Post lschen
	arPrivatePost.RemoveAll();

	// weiterzuleitende Post dem Netz zustellen
	while(!arWeiterleiten.IsEmpty())
	{
		// auslesen und lschen
		CUmschlag Umschlag = arWeiterleiten.GetHead();
		arWeiterleiten.RemoveHead();
		// an Netz senden, aber nur, wenn dem Empfnger noch vertraut wird
		if (TrustServer.arVertrauen[Umschlag.Inhalt->nEmpfaengerID][ID]>=TrustServer.nTakt)
			Netz.EmpfangeNachricht(*Umschlag.Inhalt);
	}

	// Eingangspost bearbeiten
	while(!arEingehendePost.IsEmpty())
	{
		// einen Umschlag auslesen und lschen
		CUmschlag Umschlag = arEingehendePost.GetHead();
		arEingehendePost.RemoveHead();

		// berprfen, ob weiterleiten oder private Post
		// entsprechend einordnen
		if (Umschlag.bWeiterleiten)
			arWeiterleiten.AddTail(Umschlag);
		else
			arPrivatePost.AddTail(Umschlag);
	}
}


// Nachricht lesen
CString CClient::LeseNachricht()
{
	// keine Post verfgbar ?
	if (arPrivatePost.IsEmpty())
		return "";
	
	// nchste Nachricht lesen und aus Liste lschen
	CUmschlag Umschlag = Netz.arClients[ID].arPrivatePost.GetHead();
	Netz.arClients[ID].arPrivatePost.RemoveHead();
	
	// Nachricht entschlsseln
	Umschlag.Entschluesseln(nPrivaterSchluessel);

	// Nachricht bergeben
	return Umschlag.strNachricht;
}


// Klasse CUmschlag

// Umschlag versandfertig machen
void CUmschlag::Versandfertig(TKette Kette, int Anzahl)
{
	// enthlt nchsten Umschlag
	CUmschlag *Naechster = NULL;
	
	// vom Empfnger bis zur Person vor dem Absender durcharbeiten
	int nLauf = Anzahl;
	while(nLauf!=1)
	{
		// neuen Umschlag erzeugen
		CUmschlag *Anhaengen;
		Anhaengen = new CUmschlag;

		// ist nur Zwischenumschlag
		Anhaengen->bWeiterleiten = true;
		// alle Daten eintragen
		Anhaengen->Inhalt = Naechster;
		Anhaengen->nAbsenderID = Kette[nLauf-1];
		Anhaengen->nEmpfaengerID = Kette[nLauf];

		// Empfnger ?
		if (nLauf==Anzahl)
		{
			// nicht mehr Zwischenumschlag
			Anhaengen->bWeiterleiten = false;
			// Nachricht eintragen und verschlsseln
			Anhaengen->strNachricht = this->strNachricht;
			Anhaengen->Verschluesseln(Netz.arClients[Kette[nLauf]].nOeffentlicherSchluessel);
		}

		// einfach verkettete Liste bilden
		Naechster = Anhaengen;

		// Kette durcharbeiten
		nLauf--;
	}

	// uersten Umschlag bearbeiten
	bWeiterleiten = true;
	Inhalt = Naechster;
	nAbsenderID = Kette[0];
	nEmpfaengerID = Kette[1];

	// direkte Zustellung ?
	if (Anzahl==1)
	{
		bWeiterleiten = false;
		Verschluesseln(Netz.arClients[Kette[nLauf]].nOeffentlicherSchluessel);
	}

	// Umschlagliste zurckgeben
	Inhalt = Naechster;
}


// Ver- und Entschlsseln; Placebos, in Dokumentation erklrt
void CUmschlag::Verschluesseln(TKey Schluessel)
{
}
void CUmschlag::Entschluesseln(TKey Schluessel)
{
}
