// DialogGestalten.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Zwei.h"
#include "ZweiDoc.h"
#include "DialogGestalten.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDialogGestalten 


CDialogGestalten::CDialogGestalten(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogGestalten::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogGestalten)
	m_Ecke1X = 0;
	m_Ecke1Y = 0;
	m_Ecke2X = 0;
	m_Ecke2Y = 0;
	m_ZielX = 0;
	m_ZielY = 0;
	m_StartX = 0;
	m_StartY = 0;
	m_Schritte = 0;
	//}}AFX_DATA_INIT
}


void CDialogGestalten::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogGestalten)
	DDX_Text(pDX, IDC_EDIT_ECKE1X, m_Ecke1X);
	DDX_Text(pDX, IDC_EDIT_ECKE1Y, m_Ecke1Y);
	DDX_Text(pDX, IDC_EDIT_ECKE2X, m_Ecke2X);
	DDX_Text(pDX, IDC_EDIT_ECKE2Y, m_Ecke2Y);
	DDX_Text(pDX, IDC_EDIT_ZIELX, m_ZielX);
	DDX_Text(pDX, IDC_EDIT_ZIELY, m_ZielY);
	DDX_Text(pDX, IDC_EDIT_ROYX, m_StartX);
	DDX_Text(pDX, IDC_EDIT_ROYY, m_StartY);
	DDX_Text(pDX, IDC_EDIT_SCHRITTE, m_Schritte);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogGestalten, CDialog)
	//{{AFX_MSG_MAP(CDialogGestalten)
	ON_BN_CLICKED(IDC_BUTTON_FUELLEN, OnButtonFuellen)
	ON_BN_CLICKED(IDC_BUTTON_LOESCHEN, OnButtonLoeschen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDialogGestalten 


// Bereich fllen
void CDialogGestalten::OnButtonFuellen() 
{
	// Gegenstand setzen
	SetzeBereich(GEGENSTAND);
}


// Bereich lschen
void CDialogGestalten::OnButtonLoeschen() 
{
	// Gegenstand entfernen
	SetzeBereich(LEER);
}


// Stelle bearbeiten
void CDialogGestalten::SetzeBereich(int Typ)
{
	// Daten aus Dialog holen
	UpdateData();
	
	// rechteckigen Breich verndern
	int x,y;
	for (x=m_Ecke1X; x<m_Ecke2X; x++)
		for (y=m_Ecke1Y; y<m_Ecke2Y; y++)
			m_Halle[x][y] = Typ;
}
