// DreiDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Drei.h"
#include "DreiDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDreiDlg Dialogfeld

// Initialisierung im Konstruktor
CDreiDlg::CDreiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDreiDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDreiDlg)
	m_Muttersprache = _T("");
	m_Anwesend = FALSE;
	m_NurMuttersprache = FALSE;
	m_Ergebnis = _T("");
	m_2Personen = FALSE;
	m_MaxAufschlag = 0;
	m_Grundgebuehr = 0;
	m_Kosten = 0;
	m_KuerzesterWeg = FALSE;
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// zuerst Sprachmenge leeren
	int x,y;
	for (x=0; x<UEBERSETZER; x++)
		for (y=0; y<SPRACHEN; y++)
			m_Sprachen[x][y] = UNBEKANNT;
	
	// fr jeden bersetzer die beherrschten Sprachen eintragen,
	// besondere Kennzeichnung der Muttersprache
	m_Sprachen[0][ID_DEUTSCH] = MUTTERSPRACHE;
	m_Sprachen[0][ID_ENGLISCH] = ANDERESPRACHE;
	m_Sprachen[0][ID_FRANZOESISCH] = ANDERESPRACHE;
	m_Sprachen[0][ID_ITALIENISCH] = ANDERESPRACHE;
	m_Sprachen[1][ID_DEUTSCH] = MUTTERSPRACHE;
	m_Sprachen[1][ID_SPANISCH] = ANDERESPRACHE;
	m_Sprachen[1][ID_PORTUGIESISCH] = ANDERESPRACHE;
	m_Sprachen[2][ID_SCHWYZERDUETSCH] = MUTTERSPRACHE;
	m_Sprachen[2][ID_FRANZOESISCH] = ANDERESPRACHE;
	m_Sprachen[2][ID_ITALIENISCH] = ANDERESPRACHE;
	m_Sprachen[3][ID_ENGLISCH] = MUTTERSPRACHE;
	m_Sprachen[3][ID_DAENISCH] = ANDERESPRACHE;
	m_Sprachen[3][ID_FRANZOESISCH] = ANDERESPRACHE;
	m_Sprachen[3][ID_NIEDERLAENDISCH] = ANDERESPRACHE;
	m_Sprachen[4][ID_DEUTSCH] = MUTTERSPRACHE;
	m_Sprachen[4][ID_DAENISCH] = ANDERESPRACHE;
	m_Sprachen[4][ID_SCHWEDISCH] = ANDERESPRACHE;
	m_Sprachen[5][ID_RUSSISCH] = MUTTERSPRACHE;
	m_Sprachen[5][ID_KROATISCH] = ANDERESPRACHE;
	m_Sprachen[5][ID_POLNISCH] = ANDERESPRACHE;
	m_Sprachen[5][ID_TSCHECHISCH] = ANDERESPRACHE;
	m_Sprachen[5][ID_UNGARISCH] = ANDERESPRACHE;
	m_Sprachen[6][ID_RUSSISCH] = MUTTERSPRACHE;
	m_Sprachen[6][ID_TSCHECHISCH] = ANDERESPRACHE;
	m_Sprachen[6][ID_KROATISCH] = ANDERESPRACHE;
	m_Sprachen[7][ID_KROATISCH] = MUTTERSPRACHE;
	m_Sprachen[7][ID_SERBISCH] = ANDERESPRACHE;
}

void CDreiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDreiDlg)
	DDX_Control(pDX, IDC_LIST_ANDERESPRACHEN, m_AndereSprachen);
	DDX_Control(pDX, IDC_LIST_UEBERSETZER, m_Uebersetzer);
	DDX_Control(pDX, IDC_LIST_ZIELSPRACHE, m_Zielsprache);
	DDX_Control(pDX, IDC_LIST_URSPRUNGSSPRACHE, m_Ursprungssprache);
	DDX_Control(pDX, IDC_LIST_ROUTE, m_Route);
	DDX_Text(pDX, IDC_EDIT_MUTTERSPRACHE, m_Muttersprache);
	DDX_Check(pDX, IDC_CHECK_ANWESEND, m_Anwesend);
	DDX_Check(pDX, IDC_CHECK_NURMUTTERSPRACHE, m_NurMuttersprache);
	DDX_Text(pDX, IDC_STATIC_ERGEBNIS, m_Ergebnis);
	DDX_Check(pDX, IDC_CHECK_2PERSONEN, m_2Personen);
	DDX_Text(pDX, IDC_EDIT_MAXAUFSCHLAG, m_MaxAufschlag);
	DDX_Text(pDX, IDC_EDIT_GRUNDGEBUEHR, m_Grundgebuehr);
	DDX_Text(pDX, IDC_EDIT_KOSTEN, m_Kosten);
	DDX_Check(pDX, IDC_CHECK_KUERZESTER_WEG, m_KuerzesterWeg);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDreiDlg, CDialog)
	//{{AFX_MSG_MAP(CDreiDlg)
	ON_LBN_SELCHANGE(IDC_LIST_UEBERSETZER, OnSelchangeListUebersetzer)
	ON_LBN_SELCHANGE(IDC_LIST_URSPRUNGSSPRACHE, OnSelchangeListUrsprungssprache)
	ON_LBN_SELCHANGE(IDC_LIST_ZIELSPRACHE, OnSelchangeListZielsprache)
	ON_BN_CLICKED(IDC_CHECK_NURMUTTERSPRACHE, OnCheckNurmuttersprache)
	ON_BN_CLICKED(IDC_BUTTON_INFO, OnButtonInfo)
	ON_BN_CLICKED(IDC_CHECK_2PERSONEN, OnCheck2personen)
	ON_BN_CLICKED(IDC_CHECK_ANWESEND, OnCheckAnwesend)
	ON_BN_CLICKED(IDC_CHECK_KUERZESTER_WEG, OnCheckKuerzesterWeg)
	ON_BN_CLICKED(IDC_BUTTON_WICHTIGKEIT, OnButtonWichtigkeit)
	ON_BN_CLICKED(IDC_BUTTON_TABELLE, OnButtonTabelle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDreiDlg Nachrichten-Handler

BOOL CDreiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// Listboxen leeren
	m_Ursprungssprache.ResetContent();
	m_Zielsprache.ResetContent();
	m_Route.ResetContent();
	m_Uebersetzer.ResetContent();

	// Standardgebhrenwerte eintragen
	m_Grundgebuehr = 10;
	m_MaxAufschlag = 10;
	// den krzesten Weg bei der Suche als Kriterium verwenden
	m_KuerzesterWeg = true;

	// in der Bildschirmmaske eintragen
	UpdateData(false);

	// alle Sprachen in die Sprach-Listboxen eintragen
	int nLauf;
	for (nLauf=0; nLauf<SPRACHEN; nLauf++)
	{
		CString strAusgabe;
		strAusgabe.LoadString(nLauf);

		m_Ursprungssprache.AddString(strAusgabe);
		m_Zielsprache.AddString(strAusgabe);
	}

	// alle bersetzer als anwesend markieren
	for (nLauf=0; nLauf<UEBERSETZER; nLauf++)
		m_Anwesenheit[nLauf] = true;

	// vorsorglich die Sprachmenge ermitteln
	ErzeugeGraph();

	// die bersetzer in die entsprechende Listbox eintragen
	for (nLauf=1; nLauf<=UEBERSETZER; nLauf++)
	{
		CString strAusgabe;
		strAusgabe.Format("bersetzer Nr. %d", nLauf);
		m_Uebersetzer.AddString(strAusgabe);
	}

	return TRUE;// Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}


// Adjazenzmatrix erzeugen
// dabei eventuelle Beachtung der Muttersprachenbedingung
void CDreiDlg::ErzeugeGraph()
{
	// erstmal Adjazenzmatrix leeren
	memset(m_Graph, false, sizeof(m_Graph));

	int nLauf,x,y;

	if (!m_NurMuttersprache)
	{
		// jede Sprache als Zielsprache mglich
		// jeden anwesenden bersetzer durchlaufen
		for (nLauf=0; nLauf<UEBERSETZER; nLauf++)
			if (m_Anwesenheit[nLauf])
				// alle Sprachen durchlaufen
				for (x=0; x<SPRACHEN; x++)
					// falls beherrscht, alle mglichen Zielsprachen durchlaufen
					if (m_Sprachen[nLauf][x]>0)
						for (y=0; y<SPRACHEN; y++)
							// bei gefundenem Paar die Matrix ergnzen
							if ((y!=x) && (m_Sprachen[nLauf][y]>0))
							{
								// symmetrische Matrix
								// => auch umgekehrte bersetzungsrichtung mglich
								m_Graph[x][y] = true;
								m_Graph[y][x] = true;
							}
	}
	else
	{
		// nur in Muttersprache bersetzen
		// jeden anwesenden bersetzer durchlaufen
		for (nLauf=0; nLauf<UEBERSETZER; nLauf++)
			for (x=0; x<SPRACHEN; x++)
				// nur bei Muttersprache weiterrechnen
				if (m_Sprachen[nLauf][x]==MUTTERSPRACHE)
					// alle in Frage kommenden Ursprungssprachen suchen
					for (y=0; y<SPRACHEN; y++)
						// bei gefundener Nicht-Muttersprache eintragen
						if (m_Sprachen[nLauf][y]==ANDERESPRACHE)
							m_Graph[x][y] = true;
	}
}


// Anzahl der minimal bentigten bersetzer ermitteln
int CDreiDlg::MinStationen(int nUrsprung, int nZiel)
{
	// Listbox, die das Ergebnis anzeigt, lschen
	m_Route.ResetContent();
	// Kosten lschen
	m_Kosten = 0;

	// alle Sprachen initialisieren
	int nLauf;
	for (nLauf=0; nLauf<SPRACHEN; nLauf++)
	{
		m_Optimierliste[nLauf].nStationen = INT_MAX;
		m_Optimierliste[nLauf].nNachfolger = INT_MAX;
		m_Optimierliste[nLauf].bOptimal = false;
	}

	// Zielsprache markieren
	m_Optimierliste[nZiel].nStationen = 0;
	m_Optimierliste[nZiel].bOptimal = true;

	// alle von der Zielsprache direkt erreichbaren Sprachen markieren
	for (nLauf=0; nLauf<SPRACHEN; nLauf++)
		if (m_Graph[nZiel][nLauf])
		{
			m_Optimierliste[nLauf].nStationen = 1;
			m_Optimierliste[nLauf].nNachfolger = nZiel;
		}

	// solange durchlaufen, bis Ursprungssprache erreicht
	bool bFertig = false;
	while (!bFertig)
	{
		// Minimalwerte initialisieren
		int nMinimalStationen = INT_MAX;
		int nMinimalSprache = INT_MAX;

		// nichtoptimierte Sprache, die der Zielsprache am nhesten ist, ermitteln
		// in nMinimalStationen und nMinimalSprache speichern
		for (nLauf=0; nLauf<SPRACHEN; nLauf++)
			if ((!m_Optimierliste[nLauf].bOptimal) &&
				(m_Optimierliste[nLauf].nStationen<nMinimalStationen))
			{
				nMinimalStationen = m_Optimierliste[nLauf].nStationen;
				nMinimalSprache = nLauf;
			}

		// falls keine gefunden, ist bersetzung nicht mglich -> Abbruch
		if (nMinimalSprache==INT_MAX)
			return 0;

		// von dieser Sprache ausgehend alle direkt erreichbaren Sprachen ergnzen
		for (nLauf=0; nLauf<SPRACHEN; nLauf++)
			if (m_Graph[nMinimalSprache][nLauf])
				// berprfen, ob ber neue Sprache krzere Route
				if (m_Optimierliste[nLauf].nStationen>m_Optimierliste[nMinimalSprache].nStationen)
				{
					// neue Entfernung zur Zielsprache eintragen
					m_Optimierliste[nLauf].nStationen = m_Optimierliste[nMinimalSprache].nStationen+1;
					// zur Zurckverfolgung merken
					m_Optimierliste[nLauf].nNachfolger = nMinimalSprache;
				}

		// Sprache selbst ist optimal
		m_Optimierliste[nMinimalSprache].bOptimal = true;
		// Suchende bei Erreichen der Ursprungssprache
		bFertig = (nMinimalSprache==nUrsprung);
	}

	// falls nur 2 Personen erlaubt, aber mehr fr bersetzung ntig, abbrechen
	if ((m_2Personen)&&(m_Optimierliste[nUrsprung].nStationen>2))
		return 0;

	// die benutzten Sprachen in Listbox eintragen
	if (m_Optimierliste[nUrsprung].nStationen>=2)
	{
		CString strAusgabe;

		// die Route zurckverfolgen und ausgeben
		nLauf = m_Optimierliste[nUrsprung].nNachfolger;
		while (nLauf!=nZiel)
		{
			strAusgabe.LoadString(nLauf);
			m_Route.AddString(strAusgabe);

			nLauf = m_Optimierliste[nLauf].nNachfolger;
		}
	}
	else
		// bei einer Station wurde direkt bersetzt
		if (m_Optimierliste[nUrsprung].nStationen==1)
		{
			CString strAusgabe = "(direkt bersetzt)";
			m_Route.AddString(strAusgabe);
		}

	// Anzahl bersetzer zurckgeben
	return m_Optimierliste[nUrsprung].nStationen;
}


// minimale Kosten bestimmen
// entspricht fast MinStationen
int CDreiDlg::MinKosten(int nUrsprung, int nZiel)
{
	int Kosten[SPRACHEN][SPRACHEN];
	int MoeglicheUebersetzer[SPRACHEN][SPRACHEN];
	memset(MoeglicheUebersetzer, 0, sizeof(MoeglicheUebersetzer));

	int nLauf,x,y;

	if (!m_NurMuttersprache)
	{
		// fr alle Sprachpaare die Hufigkeit bestimmen
		for (nLauf=0; nLauf<UEBERSETZER; nLauf++)
			if (m_Anwesenheit[nLauf])
				for (x=0; x<SPRACHEN; x++)
					if (m_Sprachen[nLauf][x]>0)
						for (y=0; y<SPRACHEN; y++)
							if ((y!=x) && (m_Sprachen[nLauf][y]>0))
								MoeglicheUebersetzer[x][y]++;
	}
	else
	{
		// dasselbe, nur unter Bercksichtigung der Muttersprachenklausel
		for (nLauf=0; nLauf<UEBERSETZER; nLauf++)
			if (m_Anwesenheit[nLauf])
				for (x=0; x<SPRACHEN; x++)
					if (m_Sprachen[nLauf][x]==MUTTERSPRACHE)
						for (y=0; y<SPRACHEN; y++)
							if (m_Sprachen[nLauf][y]==ANDERESPRACHE)
								MoeglicheUebersetzer[x][y]++;
	}

	// daraus ergebende Kosten errechnen (Formel in Dokumentation)
	for (x=0; x<SPRACHEN; x++)
		for (y=0; y<SPRACHEN; y++)
			if (MoeglicheUebersetzer[x][y]!=0)
				Kosten[x][y] = m_Grundgebuehr + m_MaxAufschlag/MoeglicheUebersetzer[x][y];

	// Route lschen
	m_Route.ResetContent();
	
	// alle Sprachen initialisieren
	for (nLauf=0; nLauf<SPRACHEN; nLauf++)
	{
		m_Optimierliste[nLauf].nStationen = INT_MAX;
		m_Optimierliste[nLauf].nNachfolger = INT_MAX;
		m_Optimierliste[nLauf].bOptimal = false;
	}

	// Zielsprache markieren
	m_Optimierliste[nZiel].nStationen = 0;
	m_Optimierliste[nZiel].bOptimal = true;

	// alle von der Zielsprache direkt erreichbaren Sprachen markieren
	for (nLauf=0; nLauf<SPRACHEN; nLauf++)
		if (m_Graph[nZiel][nLauf])
		{
			m_Optimierliste[nLauf].nStationen = Kosten[nZiel][nLauf];
			m_Optimierliste[nLauf].nNachfolger = nZiel;
		}

	// solange durchlaufen, bis Ursprungssprache erreicht
	bool bFertig = false;
	while (!bFertig)
	{
		// Minimalwerte initialisieren
		int nMinimalStationen = INT_MAX;
		int nMinimalSprache = INT_MAX;

		// nichtoptimierte Sprache, die der Zielsprache am nhesten ist, ermitteln
		// in nMinimalStationen und nMinimalSprache speichern
		for (nLauf=0; nLauf<SPRACHEN; nLauf++)
			if ((!m_Optimierliste[nLauf].bOptimal) &&
				(m_Optimierliste[nLauf].nStationen<nMinimalStationen))
			{
				nMinimalStationen = m_Optimierliste[nLauf].nStationen;
				nMinimalSprache = nLauf;
			}

		// falls keine gefunden, ist bersetzung nicht mglich -> Abbruch
		if (nMinimalSprache==INT_MAX)
			return 0;

		// von dieser Sprache ausgehend alle direkt erreichbaren Sprachen ergnzen
		for (nLauf=0; nLauf<SPRACHEN; nLauf++)
			if (m_Graph[nMinimalSprache][nLauf])
				// berprfen, ob ber neue Sprache krzere Route
				if (m_Optimierliste[nLauf].nStationen>
					m_Optimierliste[nMinimalSprache].nStationen+Kosten[nMinimalSprache][nLauf])
				{
					// neue Entfernung zur Zielsprache eintragen
					m_Optimierliste[nLauf].nStationen = m_Optimierliste[nMinimalSprache].nStationen+
														Kosten[nMinimalSprache][nLauf];
					// zur Zurckverfolgung merken
					m_Optimierliste[nLauf].nNachfolger = nMinimalSprache;
				}

		// Sprache selbst ist optimal
		m_Optimierliste[nMinimalSprache].bOptimal = true;
		// Suchende bei Erreichen der Ursprungssprache
		bFertig = (nMinimalSprache==nUrsprung);
	}

	
	// die benutzten Sprachen in Listbox eintragen

	CString strAusgabe;
	// die Route zurckverfolgen und ausgeben
	nLauf = m_Optimierliste[nUrsprung].nNachfolger;
	while (nLauf!=nZiel)
	{
		strAusgabe.LoadString(nLauf);
		m_Route.AddString(strAusgabe);

		nLauf = m_Optimierliste[nLauf].nNachfolger;
	}

	// Kosten zurckgeben
	return m_Optimierliste[nUrsprung].nStationen;
}


// eine bersetzung durchfhren
void CDreiDlg::NeuErmitteln()
{
	// Ursprungs- und Zielsprache ermitteln
	int nUrsprung = m_Ursprungssprache.GetCurSel();
	int	nZiel = m_Zielsprache.GetCurSel();

	// Adjazenzmatrix erzeugen
	ErzeugeGraph();

	// nur gltige Eintrge verfolgen
	if ((nUrsprung==LB_ERR)||(nZiel==LB_ERR))
		return;
	
	// wenn eine Sprache zweimal gewhlt, dann Anzahl direkt erreichbarer Sprachen ausgeben
	if (nUrsprung==nZiel)
	{
		// Zhler initialisieren
		int nDirektUebersetzbar = 0;
		
		// fr jede direkt erreichbare Sprache Zhler erhhen
		for (nZiel=0; nZiel<SPRACHEN; nZiel++)
			if (m_Graph[nZiel][nUrsprung]==true)
				nDirektUebersetzbar++;

		// ausgeben
		CString strAusgabe;
		strAusgabe.Format("In %i Sprachen direkt bersetzbar.", nDirektUebersetzbar);
		AfxMessageBox(strAusgabe);

		// Arbeit beendet
		return;
	}
		
	// von Nichterreichbarkeit ausgehen
	CString strAusgabe = "-nicht mglich-";
	// Suchmethode unterscheiden
	if (m_KuerzesterWeg)
	{
		// Weglnge ist bestimmend

		// Anzahl bersetzungen ermitteln
		int nStationen = MinStationen(nUrsprung,nZiel);
	
		// wenn erreichbar die Anzahl merken
		if (nStationen!=0)
			strAusgabe.Format("%d", nStationen);
	}
	else
	{
		// Kosten sind wichtig

		// Spezialfall rausfiltern
		if ((m_Grundgebuehr==0)&&(m_MaxAufschlag==0))
			AfxMessageBox("Grundgebhr und max. Aufschlag drfen nicht gleichzeitig 0 sein !",IDOK);
		else
		{
			// Kosten ermitteln
			m_Kosten = MinKosten(nUrsprung,nZiel);
			// falls Weg gefunden, die alte Meldung lschen
			if (m_Kosten!=0)
				strAusgabe = "";
		}
	}

	// Resultat ausgeben
	m_Ergebnis = strAusgabe;
	UpdateData(false);
}


// bei Selektion eines bersetzers aufgerufen
void CDreiDlg::OnSelchangeListUebersetzer() 
{
	// gewhlten bersetzer holen
	int nUebersetzer = m_Uebersetzer.GetCurSel();

	// Listbox der beherrschte Sprachen lschen
	m_AndereSprachen.ResetContent();

	// alle Sprachen durchlaufen
	int nLauf;
	for (nLauf=0; nLauf<SPRACHEN; nLauf++)
	{
		// Namen holen
		CString strAusgabe;
		strAusgabe.LoadString(nLauf);

		// falls "andere Sprache" -> eintragen
		if (m_Sprachen[nUebersetzer][nLauf]==ANDERESPRACHE)
			m_AndereSprachen.AddString(strAusgabe);
		// Muttersprache eintragen
		if (m_Sprachen[nUebersetzer][nLauf]==MUTTERSPRACHE)
			m_Muttersprache = strAusgabe;
	}

	// Anwesenheit eintragen
	m_Anwesend = m_Anwesenheit[nUebersetzer];
	// Bildschirm aktualisieren
	UpdateData(false);
}


// Ursprungssprache gendert
void CDreiDlg::OnSelchangeListUrsprungssprache() 
{
	// neue Daten holen, dann bersetzen
	UpdateData(true);
	NeuErmitteln();
}


// Zielsprache gendert
void CDreiDlg::OnSelchangeListZielsprache() 
{
	// neue Daten holen, dann bersetzen
	UpdateData(true);
	NeuErmitteln();
}


// Muttersprachenbedingung gendert
void CDreiDlg::OnCheckNurmuttersprache() 
{
	// neue Daten holen, dann bersetzen
	UpdateData(true);
	NeuErmitteln();
}


// max.2-Personen-Bedingung gendert
void CDreiDlg::OnCheck2personen() 
{
	// neue Daten holen, dann bersetzen
	UpdateData(true);
	NeuErmitteln();
}


// Suchmethode whlen (krzester Weg <-> Kosten)
void CDreiDlg::OnCheckKuerzesterWeg() 
{
	// neue Daten holen, dann bersetzen
	UpdateData(true);
	NeuErmitteln();
}


// Programminformation
void CDreiDlg::OnButtonInfo() 
{
	// modaler Dialog
	CAboutDlg dlg;
	dlg.DoModal();
}


// Anwesenheit gendert
void CDreiDlg::OnCheckAnwesend() 
{
	// Daten auslesen
	UpdateData(true);

	// aktuellen bersetzer bestimmen
	int nUebersetzer = m_Uebersetzer.GetCurSel();
	// Anwesenheit eintragen
	m_Anwesenheit[nUebersetzer] = m_Anwesend;

	// neu bersetzen
	NeuErmitteln();
}


// Wichtigkeit eines bersetzers bestimmen
void CDreiDlg::OnButtonWichtigkeit() 
{
	int MoeglicheUebersetzer[SPRACHEN][SPRACHEN];
	memset(MoeglicheUebersetzer, 0, sizeof(MoeglicheUebersetzer));

	int nLauf,x,y;

	// Kosten entspricht genau der bei der Kostenbestimmung
	if (!m_NurMuttersprache)
	{
		// fr alle Sprachpaare die Hufigkeit bestimmen
		for (nLauf=0; nLauf<UEBERSETZER; nLauf++)
			if (m_Anwesenheit[nLauf])
				for (x=0; x<SPRACHEN; x++)
					if (m_Sprachen[nLauf][x]>0)
						for (y=0; y<SPRACHEN; y++)
							if ((y!=x) && (m_Sprachen[nLauf][y]>0))
								MoeglicheUebersetzer[x][y]++;
	}
	else
	{
		// dasselbe, nur unter Bercksichtigung der Muttersprachenklausel
		for (nLauf=0; nLauf<UEBERSETZER; nLauf++)
			if (m_Anwesenheit[nLauf])
				for (x=0; x<SPRACHEN; x++)
					if (m_Sprachen[nLauf][x]==MUTTERSPRACHE)
						for (y=0; y<SPRACHEN; y++)
							if (m_Sprachen[nLauf][y]==ANDERESPRACHE)
								MoeglicheUebersetzer[x][y]++;
	}

	// Verlorene bersetzungen initialisieren
	int nVerloreneUebersetzungen = 0;
	// aktuellen bersetzer holen
	int nUebersetzer = m_Uebersetzer.GetCurSel();
	CString strAusgabe, strTemp;;

	// alle Sprachvariationen durchlaufen
	for (x=0; x<SPRACHEN; x++)
		for (y=0; y<SPRACHEN; y++)
			// falls Sprachpaar vom bersetzer beherrscht
			if ((m_Sprachen[nUebersetzer][x]!=0)&&(m_Sprachen[nUebersetzer][y]!=0)&&(x!=y))
			{
				// Sprachpaar ausgeben
				strTemp.LoadString(x);
				strAusgabe += strTemp +" -> ";

				strTemp.LoadString(y);
				strAusgabe += strTemp +": ";

				// Hufigkeit dieses Paares ausgeben
				strTemp.Format("%imal", MoeglicheUebersetzer[x][y]);
				strAusgabe += strTemp;

				// falls bersetzer nicht anwesend
				if (m_Anwesenheit[nUebersetzer]==false)
				{
					// falls Sprachpaar verschwunden und nicht ersetzbar
					if (MinStationen(x,y)==0)
					{
						// Anzahl erhhen
						nVerloreneUebersetzungen++;
						strAusgabe += "      (verloren)";
					}
					else
						strAusgabe += "      (ersetzbar)";
				}
				
				strAusgabe += "\n";
			}

	// durch Abwesenheit Verlorenes anzeigen
	if (m_Anwesenheit[nUebersetzer]==false)
	{
		// verlorene Sprachpaare anzeigen
		strTemp.Format("\nDurch Abwesenheit gehen %i bersetzungswege verloren.\n\n", nVerloreneUebersetzungen);
		strAusgabe += strTemp;

		// nach verlorenen Sprachen suchen
		for (x=0; x<SPRACHEN; x++)
			if (m_Sprachen[nUebersetzer][x]!=0)
			{
				// vom Verschwinden ausgehen
				bool bVerloreneSprache = true;
				for (y=0; y<SPRACHEN; y++)
					// bei min. 1 Sprachpaar doch existent
					if ((MoeglicheUebersetzer[x][y]!=0)&&(x!=y))
						bVerloreneSprache = false;

				// eventuell verlorene Sprache ausgeben
				if (bVerloreneSprache==true)
				{
					strTemp.LoadString(x);
					strAusgabe += strTemp+" ist verloren.\n";
				}
			}
	}

	// alle Operationen bisher nur im String, jetzt eigentliche Anzeige
	AfxMessageBox(strAusgabe,MB_ICONINFORMATION|MB_OK);
}


// Tabelle aller minimalen bersetzungen ausgeben
void CDreiDlg::OnButtonTabelle() 
{
	CString strAusgabe, strTemp;
	int nUrsprung, nZiel;

	// aktuelle Daten holen
	UpdateData(true);

	// alle Sprachen durchlaufen
	for (nUrsprung=0; nUrsprung<SPRACHEN; nUrsprung++)
	{
		for (nZiel=0; nZiel<SPRACHEN; nZiel++)
		{
			// davon ausgehen, da nicht bersetzbar
			strTemp = "      ";
			
			if (nUrsprung!=nZiel)
			{
				// Suchmethode unterscheiden
				if (m_KuerzesterWeg)
				{
					// Anzahl bersetzer bestimmen
					int nStationen = MinStationen(nUrsprung,nZiel);
					if (nStationen!=0)
						strTemp.Format("%5d", nStationen);
				}
				else
					// Kosten bestimmen
					strTemp.Format("%5d", MinKosten(nUrsprung,nZiel));
			}
			strAusgabe += strTemp+",";
		}
		strAusgabe += "\n";
	}

	// alles ausgeben
	AfxMessageBox(strAusgabe);
}
